package agents;

public enum AgentName {

	OPERATOR_ASSISTANT("OperatorAssistant", "OA", -1),
	FIELD_COORDINATOR("FieldCoordinator", "FC", -1),
	PLANT_MONITOR("PlantMonitor", "PM", 0),
	PRODUCTION_OPTIMISER("ProductionOptimiser", "PO", 0),
	WELL1_MONITOR("Well1Monitor", "M1", 1),
	WELL1_CONTROLLER("Well1Controller", "C1", 1),
	WELL2_MONITOR("Well2Monitor", "M2", 2),
	WELL2_CONTROLLER("Well2Controller", "C2", 2),
	WELL3_MONITOR("Well3Monitor", "M3", 3),
	WELL3_CONTROLLER("Well3Controller", "C3", 3),
	WELL4_MONITOR("Well4Monitor", "M4", 4),
	WELL4_CONTROLLER("Well4Controller", "C4", 4),
	NOT_RECOGNISED("Agent was not recognised", "XX", -1);
	
	private String name;
	private String code;
	private int id;
	
	private AgentName(String name, String code, int id) {
		this.name = name;
		this.code = code;
		this.id = id;
	}
	
	public String getName() {
		return name;
	}
	
	public String getCode() {
		return code;
	}
	
	public int getId(){
		return id;
	}
	
	public static AgentName getWellMonitorName(int id){
		switch(id) {
		case 1: return WELL1_MONITOR;
		case 2: return WELL2_MONITOR;
		case 3: return WELL3_MONITOR;
		case 4: return WELL4_MONITOR;
		}
		return NOT_RECOGNISED;
	}

	public static AgentName getWellControllerName(int id){
		switch(id) {
		case 1: return WELL1_CONTROLLER;
		case 2: return WELL2_CONTROLLER;
		case 3: return WELL3_CONTROLLER;
		case 4: return WELL4_CONTROLLER;
		}
		return NOT_RECOGNISED;
	}
	
	public static AgentName[] getWellControllerNames(int n) {
		int count = Math.min(n, 4);
		AgentName[] names = new AgentName[count];
		for(int i = 0; i < count; i++) {
			names[i] = getWellControllerName(i+1);
		}
		return names;
	}

	public static AgentName getAgentName(String name) {
		if("OperatorAssistant".equals(name)) {
			return OPERATOR_ASSISTANT;
		} else if("FieldCoordinator".equals(name)) {
			return FIELD_COORDINATOR;
		} else if("PlantMonitor".equals(name)) {
			return PLANT_MONITOR;
		} else if("ProductionOptimiser".equals(name)) {
			return PRODUCTION_OPTIMISER;
		} else if("Well1Monitor".equals(name)) {
			return WELL1_MONITOR;
		} else if("Well1Controller".equals(name)) {
			return WELL1_CONTROLLER;
		} else if("Well2Monitor".equals(name)) {
			return WELL2_MONITOR;
		} else if("Well2Controller".equals(name)) {
			return WELL2_CONTROLLER;
		} else if("Well3Monitor".equals(name)) {
			return WELL3_MONITOR;
		} else if("Well3Controller".equals(name)) {
			return WELL3_CONTROLLER;
		} else if("Well4Monitor".equals(name)) {
			return WELL4_MONITOR;
		} else if("Well4Controller".equals(name)) {
			return WELL4_CONTROLLER;
		} else {
			return NOT_RECOGNISED;
		}
	}
	
}
