package agents;

import java.math.BigDecimal;

/**
 * Convenience class used for mapping a well to its corresponding
 * production rate and water content in the optimisation process.
 * 
 * @author Lene Hallen
 * @author Lise Enmgo
 */
public class WaterWellRelation implements Comparable<WaterWellRelation> {

	private String wellName;
	private BigDecimal water;
	private BigDecimal production;
	
	/**
	 * Constructor
	 * 
	 * @param waterRatio
	 * @param wellName
	 * @param production
	 */
	public WaterWellRelation(BigDecimal waterRatio, String wellName, BigDecimal production){
		this.water = waterRatio;
		this.wellName = wellName;
		this.production = production;
	}

	public BigDecimal getWater() {
		return water;
	}

	public String getWellName() {
		return wellName;
	}
	
	public BigDecimal getProduction(){
		return production;
	}

	public int compareTo(WaterWellRelation anotherWaterWellMapping) {
		return anotherWaterWellMapping.getWater().compareTo(water);
	}
}
