/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
  This code is generated by JAC version 5.2 by
  Agent Oriented Software. http://www.agent-software.com.au

    DO NOT ALTER THIS CODE AND DO NOT REMOVE THIS COMMENT
 *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
package agents.field.plant;
import aos.jack.jak.plan.Plan;
import aos.jack.jak.plan.PlanFSM;
import aos.jack.jak.plan.ExMap;
import aos.jack.jak.agent.NameSpace;
import aos.jack.jak.event.Event;
import aos.jack.jak.task.Task;
import aos.jack.jak.core.Generator;
import aos.jack.jak.logic.Signature;
import java.math.BigDecimal;
import java.lang.Object;
import aos.jack.jak.cursor.Cursor;
import aos.jack.jak.fsm.FSM;
import aos.jack.jak.core.Jak;

/**
 * Plan responsible for analysing incoming water sensor values in order to determine 
 * whether optimisation might be needed. The analysis is based on the change in 
 * water content since the previous recorded value. If the water content has changed,
 * an <code>OptimisationClaim</code> is sent to the <code>ProductionOptimiser</code> 
 * 
 * @author Lene Hallen
 * @author Lise Engmo
 */

public class AnalyseWaterSensorValues extends aos.jack.jak.plan.Plan {
    public agents.field.plant.PlantMonitor self;
    public agents.field.plant.NewWaterSensorValueNotification newwatersensorvaluenotification0;
    public agents.field.plant.OptimisationClaim optimisationclaim1;
    public agents.field.plant.PlantWaterContent plantwatercontent1;
    private static aos.jack.jak.plan.ExMap[] __exMap_body;
    private static java.lang.String[] __tt__body = {
            "agents/field/plant/AnalyseWaterSensorValues.plan",
            "body",
            "40",
            "43",
            "44",
            "47",
            "48",
            "49",
            "52",
            "55",
            "56",
            "37"};
    private final static java.lang.String[] __planVariableNames = {
            "self",
            "newwatersensorvaluenotification0",
            "optimisationclaim1",
            "plantwatercontent1"};
    private final static java.lang.String[] __planVariableTypes = {
            "agents.field.plant.PlantMonitor",
            "agents.field.plant.NewWaterSensorValueNotification",
            "OptimisationClaim",
            "agents.field.plant.PlantWaterContent"};
    private final static java.lang.String[] __reasoningMethods = {
            "body"};
    private final static java.lang.String[] __fsmVariableNames_body = {
            "receiver",
            "time",
            "currentWater",
            "logicalPreviousWater",
            "previousWater",
            "waterChange"};
    private final static java.lang.String[] __fsmTypes_body = {
            "String",
            "int",
            "BigDecimal",
            "logical BigDecimal",
            "BigDecimal",
            "BigDecimal"};
    private final static java.lang.String[] __fsmLocalNames_body = {
            "__local__9_0",
            "__local__9_1",
            "__local__9_2",
            "__local__9_3",
            "__local__9_4",
            "__local__9_5"};
    static boolean relevant(agents.field.plant.NewWaterSensorValueNotification ev)
    {
        return true;
    }
    
    public java.lang.String getDocumentation()
    {
        return "/**\n * Plan responsible for analysing incoming water sensor values in order to determine \n * whether optimisation might be needed. The analysis is based on the change in \n * water content since the previous recorded value. If the water content has changed,\n * an <code>OptimisationClaim</code> is sent to the <code>ProductionOptimiser</code> \n * \n * @author Lene Hallen\n * @author Lise Engmo\n */\n";
    }
    
    public AnalyseWaterSensorValues()
    {
    }
    
    private AnalyseWaterSensorValues(aos.jack.jak.task.Task __t, agents.field.plant.AnalyseWaterSensorValues __env)
    {
        __agent = __env.__agent;
        __ns = __env.__ns;
        __planTask = __t;
        __logic = __t.logic;
        self = (agents.field.plant.PlantMonitor) __ns.getIF(agents.field.plant.PlantMonitor.class);
        newwatersensorvaluenotification0 = __env.newwatersensorvaluenotification0;
        optimisationclaim1 = __env.optimisationclaim1;
        plantwatercontent1 = __env.plantwatercontent1;
    }
    
    public boolean init_sentinel(aos.jack.jak.agent.NameSpace __a)
    {
        newwatersensorvaluenotification0 = (agents.field.plant.NewWaterSensorValueNotification) __a.findEvent("agents.field.plant.NewWaterSensorValueNotification");
        if (newwatersensorvaluenotification0 == null) {
            warning("Failed to find NewWaterSensorValueNotification newwatersensorvaluenotification0");
            return false;
        }
        optimisationclaim1 = (agents.field.plant.OptimisationClaim) __a.findEvent("agents.field.plant.OptimisationClaim");
        if (optimisationclaim1 == null) {
            warning("Failed to find OptimisationClaim optimisationclaim1");
            return false;
        }
        plantwatercontent1 = (agents.field.plant.PlantWaterContent) lookupNamedObject("plantwatercontent1","agents.field.plant.PlantWaterContent",0);
        if (plantwatercontent1 == null) {
            warning("Failed to find PlantWaterContent plantwatercontent1");
            return false;
        }
        return true;
    }
    
    public aos.jack.jak.plan.Plan freeze()
    {
        return this;
    }
    
    public aos.jack.jak.plan.Plan unfreeze()
    {
        return this;
    }
    
    public java.lang.Object genObject(int __index)
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal Object Construction");
        return null;
    }
    
    public aos.jack.jak.cursor.Cursor genCursor(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal Cursor Construction");
        return null;
    }
    
    public aos.jack.jak.fsm.FSM genFSM(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal FSM Construction");
        return null;
    }
    
    public boolean testCondition(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal test Construction");
        return false;
    }
    
    public aos.jack.jak.plan.PlanFSM body()
    {
        return new agents.field.plant.AnalyseWaterSensorValues.__bodyFSM();
    }
    
    private AnalyseWaterSensorValues(agents.field.plant.NewWaterSensorValueNotification __ev, aos.jack.jak.task.Task __t, agents.field.plant.AnalyseWaterSensorValues __env)
    {
        this(__t,__env);
        this.newwatersensorvaluenotification0 = __ev;
    }
    
    protected aos.jack.jak.logic.Signature eventSignature(int __log)
    {
        return newwatersensorvaluenotification0.getSignature(__log);
    }
    
    public java.lang.String handledEvent()
    {
        return "agents.field.plant.NewWaterSensorValueNotification";
    }
    
    public boolean __relevant(aos.jack.jak.event.Event __e)
    {
        return __ns.isEnabled() && relevant(((agents.field.plant.NewWaterSensorValueNotification) __e));
    }
    
    public aos.jack.jak.plan.Plan createPlan(aos.jack.jak.event.Event __e, aos.jack.jak.task.Task __t)
    {
        if (!(__e instanceof agents.field.plant.NewWaterSensorValueNotification)) 
            return null;
        agents.field.plant.NewWaterSensorValueNotification __e1 = (agents.field.plant.NewWaterSensorValueNotification) __e;
        return new agents.field.plant.AnalyseWaterSensorValues(__e1,__t,this);
    }
    
    public java.lang.String[] variableNames()
    {
        return __planVariableNames;
    }
    
    public java.lang.String[] variableTypes()
    {
        return __planVariableTypes;
    }
    
    public java.lang.Object getVariable(int n)
    {
        switch (n) {
            case 0: 
            {
                return aos.util.ToObject.box(self);
            }
            case 1: 
            {
                return aos.util.ToObject.box(newwatersensorvaluenotification0);
            }
            case 2: 
            {
                return aos.util.ToObject.box(optimisationclaim1);
            }
            case 3: 
            {
                return aos.util.ToObject.box(plantwatercontent1);
            }
            default: 
            {
                throw new java.lang.IndexOutOfBoundsException("Plan " + this + " does not have variable number " + n);
            }
        }
    }
    
    public java.lang.String[] reasoningMethods()
    {
        return mergeReasoningMethods(__reasoningMethods,super.reasoningMethods());
    }
    
    public aos.jack.jak.cursor.Cursor context()
    {
        try {
            return (((newwatersensorvaluenotification0.time > 0)?aos.jack.jak.cursor.Cursor.trueCursor:aos.jack.jak.cursor.Cursor.falseCursor));
        }
        catch (java.lang.Exception e) {
            e.printStackTrace();
            return aos.jack.jak.cursor.Cursor.falseCursor;
        }
    }
    
    class __bodyFSM extends aos.jack.jak.plan.PlanFSM implements aos.jack.jak.core.Generator {
        java.lang.String __local__9_0;
        int __local__9_1;
        java.math.BigDecimal __local__9_2;
        aos.jack.jak.logic.ObjectVariable __local__9_3;
        java.math.BigDecimal __local__9_4;
        java.math.BigDecimal __local__9_5;
        private int __breakLevel = 0;
        public int run(int __status)
            throws java.lang.Throwable
        {
            do {
                try {
                    if (__tothrow != null) 
                        throw __tothrow;
                    if ((aos.jack.jak.core.Jak.debugging & aos.jack.jak.core.Jak.LOG_PLANS) != 0) 
                        aos.util.logging.LogMsg.log(this,aos.jack.jak.core.Jak.LOG_PLANS,__task + "-AnalyseWaterSensorValues.body:" + java.lang.Integer.toString(__state));
                    if (__task.nsteps > 0) {
                        __task.nsteps-- ;
                        if (__task.nsteps == 0) 
                            agent.changeFocus();
                    }
                    if (__state < 10) {
                        __status = super.stdrun(agents.field.plant.AnalyseWaterSensorValues.this,__status);
                        if (__status != CONTINUE || agent.changing_focus) 
                            return __status;
                        continue;
                    }
                    __curstate = __state;
                    switch (__state) {
                        default: 
                        {
                            aos.jack.jak.core.Jak.error("AnalyseWaterSensorValues.body: Illegal state");
                            return FAILED_STATE;
                        }
                        //* (40)         String receiver = self.productionOptimiser.getName();
                        case 10: 
                        {
                            __breakLevel = 0;
                            __local__9_0 = self.productionOptimiser.getName();
                            __state = 11;
                            break;
                        }
                        //* (43)     	int time = newwatersensorvaluenotification0.time;
                        case 11: 
                        {
                            __local__9_1 = newwatersensorvaluenotification0.time;
                            __state = 12;
                            break;
                        }
                        //* (44)     	BigDecimal currentWater = newwatersensorvaluenotification0.currentWater;
                        case 12: 
                        {
                            __local__9_2 = newwatersensorvaluenotification0.currentWater;
                            __state = 13;
                            break;
                        }
                        //* (47)     	logical BigDecimal logicalPreviousWater;
                        case 13: 
                        {
                            __local__9_3 = (aos.jack.jak.logic.ObjectVariable) __logic.new_variable(java.math.BigDecimal.class);
                            __state = 14;
                            break;
                        }
                        //* (48)     	plantwatercontent1.get(time-1, logicalPreviousWater);
                        case 14: 
                        {
                            boolean __b;
                            aos.jack.jak.cursor.Cursor __c = null;
                            try {
                                __c = genCursor(0);
                                __b = __c.next();
                            }
                            finally {
                                if (__c != null) 
                                    __c.finished();
                            }
                            if (__b) 
                                __state = 15;
                             else 
                                throw planfailed;
                            break;
                        }
                        //* (49)     	BigDecimal previousWater = new BigDecimal(logicalPreviousWater.as_string());
                        case 15: 
                        {
                            __local__9_4 = new java.math.BigDecimal(__local__9_3.as_string());
                            __state = 16;
                            break;
                        }
                        //* (52)         BigDecimal waterChange = currentWater.subtract(previousWater);
                        case 16: 
                        {
                            __local__9_5 = __local__9_2.subtract(__local__9_4);
                            __state = 17;
                            break;
                        }
                        //* (55)         if(waterChange.compareTo(new BigDecimal(0)) != 0){
                        case 17: 
                        {
                            if (__local__9_5.compareTo(new java.math.BigDecimal(0)) != 0) 
                                __state = 18;
                             else 
                                __state = 19;
                            break;
                        }
                        //* (56)         	@send(receiver, optimisationclaim1.claim(time, currentWater, waterChange));
                        case 18: 
                        {
                            __breakLevel = 2;
                            __state = 19;
                            agent.send(__local__9_0,optimisationclaim1.claim(__local__9_1,__local__9_2,__local__9_5));
                            break;
                        }
                        //* (37)     #reasoning method
                        case 19: 
                        {
                            if (__pending == null) 
                                __state = PASSED_STATE;
                            __tothrow = __pending;
                            break;
                        }
                    }
                }
                catch (java.lang.Throwable e) {
                    handleException(e,__exMap_body);
                }
            }
             while (!agent.changing_focus);
            return CONTINUE;
        }
        
        public java.lang.String methodName()
        {
            return "body";
        }
        
        __bodyFSM()
        {
        }
        
        public java.lang.String stateInfo()
        {
            int n = __curstate;
            java.lang.String file = __tt__body[0];
            java.lang.String method = __tt__body[1];
            if (n < 0) 
                n = -n;
            n -= (10 - 2);
            java.lang.String line = (n < 2)?"??":__tt__body[n];
            return file + ":" + line + " " + method + " [" + __curstate + "]";
        }
        
        public java.lang.Object genObject(int __index)
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal Object Construction");
            return null;
        }
        
        public aos.jack.jak.cursor.Cursor genCursor(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
                case 0: 
                {
                    return (plantwatercontent1.get(__local__9_1 - 1,__local__9_3));
                }
            }
            aos.jack.jak.core.Jak.error("illegal Cursor Construction");
            return null;
        }
        
        public aos.jack.jak.fsm.FSM genFSM(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal FSM Construction");
            return null;
        }
        
        public boolean testCondition(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal test Construction");
            return false;
        }
        
        public aos.jack.jak.plan.Plan getPlan()
        {
            return agents.field.plant.AnalyseWaterSensorValues.this;
        }
        
        protected aos.jack.jak.fsm.FSM fail()
        {
            return getPlan().fail();
        }
        
        protected aos.jack.jak.fsm.FSM pass()
        {
            return getPlan().pass();
        }
        
        public void enter()
        {
            __trace = agent.trace("agents.field.plant.AnalyseWaterSensorValues.body");
        }
        
        public java.lang.Object getVariable(int n)
        {
            switch (n) {
                case 0: 
                {
                    return aos.util.ToObject.box(__local__9_0);
                }
                case 1: 
                {
                    return aos.util.ToObject.box(__local__9_1);
                }
                case 2: 
                {
                    return aos.util.ToObject.box(__local__9_2);
                }
                case 3: 
                {
                    return aos.util.ToObject.box(__local__9_3);
                }
                case 4: 
                {
                    return aos.util.ToObject.box(__local__9_4);
                }
                case 5: 
                {
                    return aos.util.ToObject.box(__local__9_5);
                }
                default: 
                {
                    throw new java.lang.IndexOutOfBoundsException("Reasoning Method " + methodName() + " does not have variable number " + n);
                }
            }
        }
        
        public java.lang.String[] variableNames()
        {
            return __fsmVariableNames_body;
        }
        
        public java.lang.String[] variableTypes()
        {
            return __fsmTypes_body;
        }
        
        public java.lang.String[] variableLocalNames()
        {
            return __fsmLocalNames_body;
        }
        
    }
}
