/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
  This code is generated by JAC version 5.2 by
  Agent Oriented Software. http://www.agent-software.com.au

    DO NOT ALTER THIS CODE AND DO NOT REMOVE THIS COMMENT
 *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
package agents.field.plant;
import aos.jack.jak.agent.Agent;
import agents.SuperAgent;
import java.math.BigDecimal;
import agents.field.well.WaterContentReply;
import agents.field.ProductionAdjustmentRequest;
import agents.AgentName;
import agents.WaterWellRelation;

/**
 * Agent responsible for carrying out the optimisation of the field's
 * production whenever this is needed. Also notifies the FieldCoordinator
 * of critical water situations in the processing plant.
 * 
 * @author Lene Hallen
 * @author Lise Engmo
 */

public class ProductionOptimiser extends agents.SuperAgent {
    protected java.math.BigDecimal upperwatercontentlimit;
    protected double upperwaterchangelimit;
    protected double wateroptimiselimit;
    protected boolean inCriticalSituation;
    protected agents.AgentName[] wellControllers;
    protected boolean[] receivedWaterContentReply;
    protected int totalReplies;
    protected agents.WaterWellRelation[] waterContents;
    protected java.math.BigDecimal maxproduction;
    public agents.field.plant.RankingWells rankingwells5;
    public agents.field.plant.AnalysingWaterSituation analysingwatersituation0;
    public agents.field.plant.CalculatingOptimalProductionRates calculatingoptimalproductionrates;
    public aos.jack.util.thread.Semaphore optimise;
    private agents.field.plant.CriticalWaterReport criticalwaterreport0;
    private agents.field.plant.WaterContentRequest watercontentrequest1;
    private agents.field.ProductionAdjustmentRequest productionadjustmentrequest2;
    private agents.field.plant.FieldOptimisationRequest fieldoptimisationrequest3;
    private agents.field.plant.RankedWellList rankedwelllist4;
    public ProductionOptimiser(agents.AgentName agentName, agents.AgentName[] wellcontrollers, java.math.BigDecimal ucontentl, java.math.BigDecimal maxprod)
    {
        super(agentName);
        boolean __b = getAgentType() == agents.field.plant.ProductionOptimiser.class;
        if (__b) {
            __init1();
            __init2();
        }
        // an alarm will be sent and the worst well is asked to close:

        upperwatercontentlimit = ucontentl;
        // the production of all wells is reduced

        upperwaterchangelimit = ucontentl.doubleValue() - 5;
        // the production is reduced for the most water-producing well

        wateroptimiselimit = upperwaterchangelimit - 15;
        maxproduction = maxprod;
        inCriticalSituation = false;
        this.wellControllers = wellcontrollers;
        waterContents = new agents.WaterWellRelation[wellControllers.length];
        receivedWaterContentReply = new boolean[wellControllers.length];
        for (int i = 0; i < receivedWaterContentReply.length; i++ ) {
            receivedWaterContentReply[i] = false;
        }
        totalReplies = 0;
        optimise.signal();
        if (__b) 
            startAgent();
    }
    
    public java.lang.String getDocumentation()
    {
        return "/**\n * Agent responsible for carrying out the optimisation of the field\'s\n * production whenever this is needed. Also notifies the FieldCoordinator\n * of critical water situations in the processing plant.\n * \n * @author Lene Hallen\n * @author Lise Engmo\n */\n";
    }
    
    public java.lang.Class getAgentType()
    {
        return agents.field.plant.ProductionOptimiser.class;
    }
    
    public void __init1()
    {
        super.__init1();
        if (rankingwells5 == null) {
            rankingwells5 = new agents.field.plant.RankingWells(this);
            rankingwells5.__initCapability(this,"rankingwells5");
        }
        rankingwells5.__init1();
        if (analysingwatersituation0 == null) {
            analysingwatersituation0 = new agents.field.plant.AnalysingWaterSituation(this);
            analysingwatersituation0.__initCapability(this,"analysingwatersituation0");
        }
        analysingwatersituation0.__init1();
        if (calculatingoptimalproductionrates == null) {
            calculatingoptimalproductionrates = new agents.field.plant.CalculatingOptimalProductionRates(this);
            calculatingoptimalproductionrates.__initCapability(this,"calculatingoptimalproductionrates");
        }
        calculatingoptimalproductionrates.__init1();
        setNamedCreator("optimise","aos.jack.util.thread.Semaphore",new aos.jack.jak.agent.DataCreator(true){
            public java.lang.Object create()
            {
                return __named_data_optimise();
            }
            
        },true);
    }
    
    public void __init2()
    {
        super.__init2();
        rankingwells5.__init2();
        analysingwatersituation0.__init2();
        calculatingoptimalproductionrates.__init2();
        getNamedObject("optimise","aos.jack.util.thread.Semaphore");
        criticalwaterreport0 = (agents.field.plant.CriticalWaterReport) findEvent("agents.field.plant.CriticalWaterReport");
        watercontentrequest1 = (agents.field.plant.WaterContentRequest) findEvent("agents.field.plant.WaterContentRequest");
        productionadjustmentrequest2 = (agents.field.ProductionAdjustmentRequest) findEvent("agents.field.ProductionAdjustmentRequest");
        fieldoptimisationrequest3 = (agents.field.plant.FieldOptimisationRequest) findEvent("agents.field.plant.FieldOptimisationRequest");
        rankedwelllist4 = (agents.field.plant.RankedWellList) findEvent("agents.field.plant.RankedWellList");
    }
    
    synchronized private void __init_desc()
    {
        rankingwells5 = new agents.field.plant.RankingWells(this);
        rankingwells5.__initCapability(this,"rankingwells5");
        rankingwells5.init_desc();
        analysingwatersituation0 = new agents.field.plant.AnalysingWaterSituation(this);
        analysingwatersituation0.__initCapability(this,"analysingwatersituation0");
        analysingwatersituation0.init_desc();
        calculatingoptimalproductionrates = new agents.field.plant.CalculatingOptimalProductionRates(this);
        calculatingoptimalproductionrates.__initCapability(this,"calculatingoptimalproductionrates");
        calculatingoptimalproductionrates.init_desc();
        addNamedObject("optimise","aos.jack.util.thread.Semaphore",aos.jack.jak.agent.Agent.WRITEABLE);
        addEvent("agents.field.plant.OptimisationClaim",aos.jack.jak.agent.Agent.HANDLED_EVENT);
        addEvent("agents.field.well.WaterContentReply",aos.jack.jak.agent.Agent.HANDLED_EVENT);
        addEvent("agents.field.plant.FieldOptimisationRequest",aos.jack.jak.agent.Agent.HANDLED_EVENT);
        addEvent("agents.field.plant.RankedWellList",aos.jack.jak.agent.Agent.HANDLED_EVENT);
        addEvent("agents.field.plant.CriticalWaterReport",aos.jack.jak.agent.Agent.SENT_EVENT);
        addEvent("agents.field.plant.WaterContentRequest",aos.jack.jak.agent.Agent.SENT_EVENT);
        addEvent("agents.field.ProductionAdjustmentRequest",aos.jack.jak.agent.Agent.SENT_EVENT);
        addEvent("agents.field.plant.FieldOptimisationRequest",aos.jack.jak.agent.Agent.POSTED_EVENT);
        addEvent("agents.field.plant.RankedWellList",aos.jack.jak.agent.Agent.POSTED_EVENT);
    }
    
    public void init_desc()
    {
        newAgentDesc("ProductionOptimiser");
        super.init_desc();
        __init_desc();
    }
    
    synchronized public void __bindNames()
    {
        super.__bindNames();
        rankingwells5.__bindNames();
        analysingwatersituation0.__bindNames();
        calculatingoptimalproductionrates.__bindNames();
    }
    
    public void setEnabled(boolean t)
    {
        super.setEnabled(t);
        rankingwells5.setEnabled(t);
        analysingwatersituation0.setEnabled(t);
        calculatingoptimalproductionrates.setEnabled(t);
    }
    
    private aos.jack.util.thread.Semaphore __named_data_optimise()
    {
        if (optimise != null) 
            return optimise;
        optimise = new aos.jack.util.thread.Semaphore();
        setNamedObject("optimise","aos.jack.util.thread.Semaphore",optimise);
        return optimise;
    }
    
}
