/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
  This code is generated by JAC version 5.2 by
  Agent Oriented Software. http://www.agent-software.com.au

    DO NOT ALTER THIS CODE AND DO NOT REMOVE THIS COMMENT
 *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
package agents.field.well;
import aos.jack.jak.plan.Plan;
import aos.jack.jak.plan.PlanFSM;
import aos.jack.jak.plan.ExMap;
import aos.jack.jak.agent.NameSpace;
import aos.jack.jak.event.Event;
import aos.jack.jak.task.Task;
import aos.jack.jak.core.Generator;
import aos.jack.jak.logic.Signature;
import java.math.BigDecimal;
import java.lang.Object;
import aos.jack.jak.cursor.Cursor;
import aos.jack.jak.fsm.FSM;
import aos.jack.jak.core.Jak;

/**
 * Plan responsible for analysing incoming sand sensor values in order to determine 
 * whether further analysis might be needed. The analysis is based on the change in 
 * sand content since the previous recorded value. If the sand content has changed,
 * a <code>SandDetectedReport</code> is sent to the <code>WellController</code> 
 * 
 * @author Lene Hallen
 * @author Lise Engmo
 */

public class AnalyseSandSensorValues extends aos.jack.jak.plan.Plan {
    public agents.field.well.WellMonitor self;
    public agents.field.well.NewSandSensorValueNotification newsandsensorvaluenotification0;
    public agents.field.well.SandDetectedReport sanddetectedreport1;
    public agents.field.well.WellSandContent wellsandcontent0;
    public agents.field.well.WellProductionRate wellproductionrate0;
    private static aos.jack.jak.plan.ExMap[] __exMap_body;
    private static java.lang.String[] __tt__body = {
            "agents/field/well/AnalyseSandSensorValues.plan",
            "body",
            "39",
            "42",
            "43",
            "46",
            "47",
            "48",
            "51",
            "52",
            "53",
            "56",
            "57",
            "36"};
    private final static java.lang.String[] __planVariableNames = {
            "self",
            "newsandsensorvaluenotification0",
            "sanddetectedreport1",
            "wellsandcontent0",
            "wellproductionrate0"};
    private final static java.lang.String[] __planVariableTypes = {
            "agents.field.well.WellMonitor",
            "agents.field.well.NewSandSensorValueNotification",
            "SandDetectedReport",
            "agents.field.well.WellSandContent",
            "agents.field.well.WellProductionRate"};
    private final static java.lang.String[] __reasoningMethods = {
            "body"};
    private final static java.lang.String[] __fsmVariableNames_body = {
            "receiver",
            "time",
            "currentSand",
            "logicalCurrentProduction",
            "currentProduction",
            "logicalPreviousSand",
            "previousSand"};
    private final static java.lang.String[] __fsmTypes_body = {
            "String",
            "int",
            "BigDecimal",
            "logical BigDecimal",
            "BigDecimal",
            "logical BigDecimal",
            "BigDecimal"};
    private final static java.lang.String[] __fsmLocalNames_body = {
            "__local__22_0",
            "__local__22_1",
            "__local__22_2",
            "__local__22_3",
            "__local__22_4",
            "__local__22_5",
            "__local__22_6"};
    static boolean relevant(agents.field.well.NewSandSensorValueNotification ev)
    {
        return true;
    }
    
    public java.lang.String getDocumentation()
    {
        return "/**\n * Plan responsible for analysing incoming sand sensor values in order to determine \n * whether further analysis might be needed. The analysis is based on the change in \n * sand content since the previous recorded value. If the sand content has changed,\n * a <code>SandDetectedReport</code> is sent to the <code>WellController</code> \n * \n * @author Lene Hallen\n * @author Lise Engmo\n */\n";
    }
    
    public AnalyseSandSensorValues()
    {
    }
    
    private AnalyseSandSensorValues(aos.jack.jak.task.Task __t, agents.field.well.AnalyseSandSensorValues __env)
    {
        __agent = __env.__agent;
        __ns = __env.__ns;
        __planTask = __t;
        __logic = __t.logic;
        self = (agents.field.well.WellMonitor) __ns.getIF(agents.field.well.WellMonitor.class);
        newsandsensorvaluenotification0 = __env.newsandsensorvaluenotification0;
        sanddetectedreport1 = __env.sanddetectedreport1;
        wellsandcontent0 = __env.wellsandcontent0;
        wellproductionrate0 = __env.wellproductionrate0;
    }
    
    public boolean init_sentinel(aos.jack.jak.agent.NameSpace __a)
    {
        newsandsensorvaluenotification0 = (agents.field.well.NewSandSensorValueNotification) __a.findEvent("agents.field.well.NewSandSensorValueNotification");
        if (newsandsensorvaluenotification0 == null) {
            warning("Failed to find NewSandSensorValueNotification newsandsensorvaluenotification0");
            return false;
        }
        sanddetectedreport1 = (agents.field.well.SandDetectedReport) __a.findEvent("agents.field.well.SandDetectedReport");
        if (sanddetectedreport1 == null) {
            warning("Failed to find SandDetectedReport sanddetectedreport1");
            return false;
        }
        wellsandcontent0 = (agents.field.well.WellSandContent) lookupNamedObject("wellsandcontent0","agents.field.well.WellSandContent",0);
        if (wellsandcontent0 == null) {
            warning("Failed to find WellSandContent wellsandcontent0");
            return false;
        }
        wellproductionrate0 = (agents.field.well.WellProductionRate) lookupNamedObject("wellproductionrate0","agents.field.well.WellProductionRate",0);
        if (wellproductionrate0 == null) {
            warning("Failed to find WellProductionRate wellproductionrate0");
            return false;
        }
        return true;
    }
    
    public aos.jack.jak.plan.Plan freeze()
    {
        return this;
    }
    
    public aos.jack.jak.plan.Plan unfreeze()
    {
        return this;
    }
    
    public java.lang.Object genObject(int __index)
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal Object Construction");
        return null;
    }
    
    public aos.jack.jak.cursor.Cursor genCursor(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal Cursor Construction");
        return null;
    }
    
    public aos.jack.jak.fsm.FSM genFSM(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal FSM Construction");
        return null;
    }
    
    public boolean testCondition(int __index)
        throws java.lang.Exception
    {
        switch (__index) {
        }
        aos.jack.jak.core.Jak.error("illegal test Construction");
        return false;
    }
    
    public aos.jack.jak.plan.PlanFSM body()
    {
        return new agents.field.well.AnalyseSandSensorValues.__bodyFSM();
    }
    
    private AnalyseSandSensorValues(agents.field.well.NewSandSensorValueNotification __ev, aos.jack.jak.task.Task __t, agents.field.well.AnalyseSandSensorValues __env)
    {
        this(__t,__env);
        this.newsandsensorvaluenotification0 = __ev;
    }
    
    protected aos.jack.jak.logic.Signature eventSignature(int __log)
    {
        return newsandsensorvaluenotification0.getSignature(__log);
    }
    
    public java.lang.String handledEvent()
    {
        return "agents.field.well.NewSandSensorValueNotification";
    }
    
    public boolean __relevant(aos.jack.jak.event.Event __e)
    {
        return __ns.isEnabled() && relevant(((agents.field.well.NewSandSensorValueNotification) __e));
    }
    
    public aos.jack.jak.plan.Plan createPlan(aos.jack.jak.event.Event __e, aos.jack.jak.task.Task __t)
    {
        if (!(__e instanceof agents.field.well.NewSandSensorValueNotification)) 
            return null;
        agents.field.well.NewSandSensorValueNotification __e1 = (agents.field.well.NewSandSensorValueNotification) __e;
        return new agents.field.well.AnalyseSandSensorValues(__e1,__t,this);
    }
    
    public java.lang.String[] variableNames()
    {
        return __planVariableNames;
    }
    
    public java.lang.String[] variableTypes()
    {
        return __planVariableTypes;
    }
    
    public java.lang.Object getVariable(int n)
    {
        switch (n) {
            case 0: 
            {
                return aos.util.ToObject.box(self);
            }
            case 1: 
            {
                return aos.util.ToObject.box(newsandsensorvaluenotification0);
            }
            case 2: 
            {
                return aos.util.ToObject.box(sanddetectedreport1);
            }
            case 3: 
            {
                return aos.util.ToObject.box(wellsandcontent0);
            }
            case 4: 
            {
                return aos.util.ToObject.box(wellproductionrate0);
            }
            default: 
            {
                throw new java.lang.IndexOutOfBoundsException("Plan " + this + " does not have variable number " + n);
            }
        }
    }
    
    public java.lang.String[] reasoningMethods()
    {
        return mergeReasoningMethods(__reasoningMethods,super.reasoningMethods());
    }
    
    public aos.jack.jak.cursor.Cursor context()
    {
        try {
            return (((newsandsensorvaluenotification0.currentSand.doubleValue() > 0 && newsandsensorvaluenotification0.time > 0)?aos.jack.jak.cursor.Cursor.trueCursor:aos.jack.jak.cursor.Cursor.falseCursor));
        }
        catch (java.lang.Exception e) {
            e.printStackTrace();
            return aos.jack.jak.cursor.Cursor.falseCursor;
        }
    }
    
    class __bodyFSM extends aos.jack.jak.plan.PlanFSM implements aos.jack.jak.core.Generator {
        java.lang.String __local__22_0;
        int __local__22_1;
        java.math.BigDecimal __local__22_2;
        aos.jack.jak.logic.ObjectVariable __local__22_3;
        java.math.BigDecimal __local__22_4;
        aos.jack.jak.logic.ObjectVariable __local__22_5;
        java.math.BigDecimal __local__22_6;
        private int __breakLevel = 0;
        public int run(int __status)
            throws java.lang.Throwable
        {
            do {
                try {
                    if (__tothrow != null) 
                        throw __tothrow;
                    if ((aos.jack.jak.core.Jak.debugging & aos.jack.jak.core.Jak.LOG_PLANS) != 0) 
                        aos.util.logging.LogMsg.log(this,aos.jack.jak.core.Jak.LOG_PLANS,__task + "-AnalyseSandSensorValues.body:" + java.lang.Integer.toString(__state));
                    if (__task.nsteps > 0) {
                        __task.nsteps-- ;
                        if (__task.nsteps == 0) 
                            agent.changeFocus();
                    }
                    if (__state < 10) {
                        __status = super.stdrun(agents.field.well.AnalyseSandSensorValues.this,__status);
                        if (__status != CONTINUE || agent.changing_focus) 
                            return __status;
                        continue;
                    }
                    __curstate = __state;
                    switch (__state) {
                        default: 
                        {
                            aos.jack.jak.core.Jak.error("AnalyseSandSensorValues.body: Illegal state");
                            return FAILED_STATE;
                        }
                        //* (39)     	String receiver = self.wellController.getName();
                        case 10: 
                        {
                            __breakLevel = 0;
                            __local__22_0 = self.wellController.getName();
                            __state = 11;
                            break;
                        }
                        //* (42)     	int time = newsandsensorvaluenotification0.time;
                        case 11: 
                        {
                            __local__22_1 = newsandsensorvaluenotification0.time;
                            __state = 12;
                            break;
                        }
                        //* (43)     	BigDecimal currentSand = newsandsensorvaluenotification0.currentSand;
                        case 12: 
                        {
                            __local__22_2 = newsandsensorvaluenotification0.currentSand;
                            __state = 13;
                            break;
                        }
                        //* (46)     	logical BigDecimal logicalCurrentProduction;
                        case 13: 
                        {
                            __local__22_3 = (aos.jack.jak.logic.ObjectVariable) __logic.new_variable(java.math.BigDecimal.class);
                            __state = 14;
                            break;
                        }
                        //* (47)     	wellproductionrate0.get(time, logicalCurrentProduction);
                        case 14: 
                        {
                            boolean __b;
                            aos.jack.jak.cursor.Cursor __c = null;
                            try {
                                __c = genCursor(0);
                                __b = __c.next();
                            }
                            finally {
                                if (__c != null) 
                                    __c.finished();
                            }
                            if (__b) 
                                __state = 15;
                             else 
                                throw planfailed;
                            break;
                        }
                        //* (48)     	BigDecimal currentProduction = new BigDecimal(logicalCurrentProduction.as_string());
                        case 15: 
                        {
                            __local__22_4 = new java.math.BigDecimal(__local__22_3.as_string());
                            __state = 16;
                            break;
                        }
                        //* (51)     	logical BigDecimal logicalPreviousSand;
                        case 16: 
                        {
                            __local__22_5 = (aos.jack.jak.logic.ObjectVariable) __logic.new_variable(java.math.BigDecimal.class);
                            __state = 17;
                            break;
                        }
                        //* (52)     	wellsandcontent0.get(time-1, logicalPreviousSand);
                        case 17: 
                        {
                            boolean __b;
                            aos.jack.jak.cursor.Cursor __c = null;
                            try {
                                __c = genCursor(1);
                                __b = __c.next();
                            }
                            finally {
                                if (__c != null) 
                                    __c.finished();
                            }
                            if (__b) 
                                __state = 18;
                             else 
                                throw planfailed;
                            break;
                        }
                        //* (53)     	BigDecimal previousSand = new BigDecimal(logicalPreviousSand.as_string());
                        case 18: 
                        {
                            __local__22_6 = new java.math.BigDecimal(__local__22_5.as_string());
                            __state = 19;
                            break;
                        }
                        //* (56)     	if(currentSand.compareTo(previousSand) != 0){
                        case 19: 
                        {
                            if (__local__22_2.compareTo(__local__22_6) != 0) 
                                __state = 20;
                             else 
                                __state = 21;
                            break;
                        }
                        //* (57)     		@send(receiver, sanddetectedreport1.sandreport(time, currentProduction, currentSand, previousSand));
                        case 20: 
                        {
                            __breakLevel = 2;
                            __state = 21;
                            agent.send(__local__22_0,sanddetectedreport1.sandreport(__local__22_1,__local__22_4,__local__22_2,__local__22_6));
                            break;
                        }
                        //* (36)     #reasoning method
                        case 21: 
                        {
                            if (__pending == null) 
                                __state = PASSED_STATE;
                            __tothrow = __pending;
                            break;
                        }
                    }
                }
                catch (java.lang.Throwable e) {
                    handleException(e,__exMap_body);
                }
            }
             while (!agent.changing_focus);
            return CONTINUE;
        }
        
        public java.lang.String methodName()
        {
            return "body";
        }
        
        __bodyFSM()
        {
        }
        
        public java.lang.String stateInfo()
        {
            int n = __curstate;
            java.lang.String file = __tt__body[0];
            java.lang.String method = __tt__body[1];
            if (n < 0) 
                n = -n;
            n -= (10 - 2);
            java.lang.String line = (n < 2)?"??":__tt__body[n];
            return file + ":" + line + " " + method + " [" + __curstate + "]";
        }
        
        public java.lang.Object genObject(int __index)
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal Object Construction");
            return null;
        }
        
        public aos.jack.jak.cursor.Cursor genCursor(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
                case 0: 
                {
                    return (wellproductionrate0.get(__local__22_1,__local__22_3));
                }
                case 1: 
                {
                    return (wellsandcontent0.get(__local__22_1 - 1,__local__22_5));
                }
            }
            aos.jack.jak.core.Jak.error("illegal Cursor Construction");
            return null;
        }
        
        public aos.jack.jak.fsm.FSM genFSM(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal FSM Construction");
            return null;
        }
        
        public boolean testCondition(int __index)
            throws java.lang.Exception
        {
            switch (__index) {
            }
            aos.jack.jak.core.Jak.error("illegal test Construction");
            return false;
        }
        
        public aos.jack.jak.plan.Plan getPlan()
        {
            return agents.field.well.AnalyseSandSensorValues.this;
        }
        
        protected aos.jack.jak.fsm.FSM fail()
        {
            return getPlan().fail();
        }
        
        protected aos.jack.jak.fsm.FSM pass()
        {
            return getPlan().pass();
        }
        
        public void enter()
        {
            __trace = agent.trace("agents.field.well.AnalyseSandSensorValues.body");
        }
        
        public java.lang.Object getVariable(int n)
        {
            switch (n) {
                case 0: 
                {
                    return aos.util.ToObject.box(__local__22_0);
                }
                case 1: 
                {
                    return aos.util.ToObject.box(__local__22_1);
                }
                case 2: 
                {
                    return aos.util.ToObject.box(__local__22_2);
                }
                case 3: 
                {
                    return aos.util.ToObject.box(__local__22_3);
                }
                case 4: 
                {
                    return aos.util.ToObject.box(__local__22_4);
                }
                case 5: 
                {
                    return aos.util.ToObject.box(__local__22_5);
                }
                case 6: 
                {
                    return aos.util.ToObject.box(__local__22_6);
                }
                default: 
                {
                    throw new java.lang.IndexOutOfBoundsException("Reasoning Method " + methodName() + " does not have variable number " + n);
                }
            }
        }
        
        public java.lang.String[] variableNames()
        {
            return __fsmVariableNames_body;
        }
        
        public java.lang.String[] variableTypes()
        {
            return __fsmTypes_body;
        }
        
        public java.lang.String[] variableLocalNames()
        {
            return __fsmLocalNames_body;
        }
        
    }
}
