/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
  This code is generated by JAC version 5.2 by
  Agent Oriented Software. http://www.agent-software.com.au

    DO NOT ALTER THIS CODE AND DO NOT REMOVE THIS COMMENT
 *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
package agents.field.well;
import aos.jack.jak.agent.Agent;
import agents.SuperAgent;
import simulator.field.Choke;
import java.math.BigDecimal;
import agents.AgentName;
import agents.field.plant.WaterContentRequest;
import agents.field.ProductionAdjustmentRequest;

/**
 * Agent which is responsible for calculating and actuating new choke positions.
 * Also forwards water content requests and replies between the well monitor and
 * the production optimiser.
 * 
 * @author Lene Hallen
 * @author Lise Engmo
 */

public class WellController extends agents.SuperAgent {
    protected simulator.field.Choke choke;
    protected agents.AgentName wellMonitor;
    protected java.math.BigDecimal maxproduction;
    protected java.math.BigDecimal productionChokePermDependency;
    protected java.math.BigDecimal criticalSandLimit;
    protected java.math.BigDecimal nonCriticalSandLimit;
    protected boolean inCriticalSituation;
    public agents.field.well.HandlingWaterContentRequest handlingwatercontentrequest6;
    public agents.field.well.AnalysingSandContentSituation analysingsandcontentsituation1;
    public agents.field.well.ActuatingChokePositionChange actuatingchokepositionchange1;
    public agents.field.well.ChokePosition chokeposition0;
    private agents.field.well.CriticalSandReport criticalsandreport1;
    private agents.field.well.WaterContentReply watercontentreply2;
    private agents.field.plant.WaterContentRequest watercontentrequest3;
    private agents.field.ProductionAdjustmentRequest productionadjustmentrequest4;
    private agents.field.well.ChokeAdjustmentRequest chokeadjustmentrequest5;
    private agents.field.well.ChokeAdjustmentInternalRequest chokeadjustmentinternalrequest1;
    /**
     * Constructor. Initializes the agent's fields.
     */

    public WellController(agents.AgentName agentName, simulator.field.Choke choke, agents.AgentName wellMonitor, java.math.BigDecimal maxproduction, java.math.BigDecimal productionChokePermDependency, java.math.BigDecimal criticalSandLimit)
    {
        super(agentName);
        boolean __b = getAgentType() == agents.field.well.WellController.class;
        if (__b) {
            __init1();
            __init2();
        }
        this.choke = choke;
        this.wellMonitor = wellMonitor;
        this.maxproduction = maxproduction;
        this.productionChokePermDependency = productionChokePermDependency;
        this.criticalSandLimit = criticalSandLimit;
        this.nonCriticalSandLimit = criticalSandLimit.multiply(new java.math.BigDecimal(0.7));
        inCriticalSituation = false;
        if (__b) 
            startAgent();
    }
    
    public java.lang.String getDocumentation()
    {
        return "/**\n * Agent which is responsible for calculating and actuating new choke positions.\n * Also forwards water content requests and replies between the well monitor and\n * the production optimiser.\n * \n * @author Lene Hallen\n * @author Lise Engmo\n */\n";
    }
    
    public java.lang.Class getAgentType()
    {
        return agents.field.well.WellController.class;
    }
    
    public void __init1()
    {
        super.__init1();
        if (handlingwatercontentrequest6 == null) {
            handlingwatercontentrequest6 = new agents.field.well.HandlingWaterContentRequest(this);
            handlingwatercontentrequest6.__initCapability(this,"handlingwatercontentrequest6");
        }
        handlingwatercontentrequest6.__init1();
        if (analysingsandcontentsituation1 == null) {
            analysingsandcontentsituation1 = new agents.field.well.AnalysingSandContentSituation(this);
            analysingsandcontentsituation1.__initCapability(this,"analysingsandcontentsituation1");
        }
        analysingsandcontentsituation1.__init1();
        if (actuatingchokepositionchange1 == null) {
            actuatingchokepositionchange1 = new agents.field.well.ActuatingChokePositionChange(this);
            actuatingchokepositionchange1.__initCapability(this,"actuatingchokepositionchange1");
        }
        actuatingchokepositionchange1.__init1();
        setNamedCreator("chokeposition0","agents.field.well.ChokePosition",new aos.jack.jak.agent.DataCreator(true){
            public java.lang.Object create()
            {
                return __named_data_chokeposition0();
            }
            
        },true);
    }
    
    public void __init2()
    {
        super.__init2();
        handlingwatercontentrequest6.__init2();
        analysingsandcontentsituation1.__init2();
        actuatingchokepositionchange1.__init2();
        criticalsandreport1 = (agents.field.well.CriticalSandReport) findEvent("agents.field.well.CriticalSandReport");
        watercontentreply2 = (agents.field.well.WaterContentReply) findEvent("agents.field.well.WaterContentReply");
        watercontentrequest3 = (agents.field.plant.WaterContentRequest) findEvent("agents.field.plant.WaterContentRequest");
        productionadjustmentrequest4 = (agents.field.ProductionAdjustmentRequest) findEvent("agents.field.ProductionAdjustmentRequest");
        chokeadjustmentrequest5 = (agents.field.well.ChokeAdjustmentRequest) findEvent("agents.field.well.ChokeAdjustmentRequest");
        chokeadjustmentinternalrequest1 = (agents.field.well.ChokeAdjustmentInternalRequest) findEvent("agents.field.well.ChokeAdjustmentInternalRequest");
        getNamedObject("chokeposition0","agents.field.well.ChokePosition");
    }
    
    synchronized private void __init_desc()
    {
        handlingwatercontentrequest6 = new agents.field.well.HandlingWaterContentRequest(this);
        handlingwatercontentrequest6.__initCapability(this,"handlingwatercontentrequest6");
        handlingwatercontentrequest6.init_desc();
        analysingsandcontentsituation1 = new agents.field.well.AnalysingSandContentSituation(this);
        analysingsandcontentsituation1.__initCapability(this,"analysingsandcontentsituation1");
        analysingsandcontentsituation1.init_desc();
        actuatingchokepositionchange1 = new agents.field.well.ActuatingChokePositionChange(this);
        actuatingchokepositionchange1.__initCapability(this,"actuatingchokepositionchange1");
        actuatingchokepositionchange1.init_desc();
        addNamedObject("chokeposition0","agents.field.well.ChokePosition",aos.jack.jak.agent.Agent.WRITEABLE);
        addEvent("agents.field.well.SandDetectedReport",aos.jack.jak.agent.Agent.HANDLED_EVENT);
        addEvent("agents.field.well.ChokeAdjustmentRequest",aos.jack.jak.agent.Agent.HANDLED_EVENT);
        addEvent("agents.field.plant.WaterContentRequest",aos.jack.jak.agent.Agent.HANDLED_EVENT);
        addEvent("agents.field.ProductionAdjustmentRequest",aos.jack.jak.agent.Agent.HANDLED_EVENT);
        addEvent("agents.field.well.WaterContentReply",aos.jack.jak.agent.Agent.HANDLED_EVENT);
        addEvent("agents.field.well.ChokeAdjustmentInternalRequest",aos.jack.jak.agent.Agent.HANDLED_EVENT);
        addEvent("agents.field.well.CriticalSandReport",aos.jack.jak.agent.Agent.SENT_EVENT);
        addEvent("agents.field.well.WaterContentReply",aos.jack.jak.agent.Agent.SENT_EVENT);
        addEvent("agents.field.plant.WaterContentRequest",aos.jack.jak.agent.Agent.SENT_EVENT);
        addEvent("agents.field.ProductionAdjustmentRequest",aos.jack.jak.agent.Agent.SENT_EVENT);
        addEvent("agents.field.well.ChokeAdjustmentRequest",aos.jack.jak.agent.Agent.SENT_EVENT);
        addEvent("agents.field.well.ChokeAdjustmentInternalRequest",aos.jack.jak.agent.Agent.POSTED_EVENT);
        addPlan("agents.field.well.CalculateChokePosition",0);
        addPlan("agents.field.well.SendInternalChokeAdjustmentCommand",0);
    }
    
    public void init_desc()
    {
        newAgentDesc("WellController");
        super.init_desc();
        __init_desc();
    }
    
    synchronized public void __bindNames()
    {
        super.__bindNames();
        handlingwatercontentrequest6.__bindNames();
        analysingsandcontentsituation1.__bindNames();
        actuatingchokepositionchange1.__bindNames();
    }
    
    public void setEnabled(boolean t)
    {
        super.setEnabled(t);
        handlingwatercontentrequest6.setEnabled(t);
        analysingsandcontentsituation1.setEnabled(t);
        actuatingchokepositionchange1.setEnabled(t);
    }
    
    private agents.field.well.ChokePosition __named_data_chokeposition0()
    {
        if (chokeposition0 != null) 
            return chokeposition0;
        chokeposition0 = new agents.field.well.ChokePosition();
        if (!chokeposition0.attach(this)) 
            chokeposition0 = null;
        setNamedObject("chokeposition0","agents.field.well.ChokePosition",chokeposition0);
        return chokeposition0;
    }
    
}
