package simulator;

import javax.swing.UIManager;

import simulator.config.StartupScreen;
import simulator.constants.Constants;

/**
 * This class is the entry point of the test framework which simulates a running oil field. 
 * PLEASE NOTE that changes need to be made here before exporting the project to jar.
 * 
 * @author Lene Hallen
 * @author Lise Engmo
 */
public class Simulator implements Constants {

	/**
	 * Main method. Sets the look and feel and starts up the simulator.
	 * 
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {
		System.out.println("--- Start ---");
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(0);
		}
		new StartupScreen();
	}

}
