package simulator.constants;

/**
 * Enum for the possible choke adjusters. The choke can be adjusted by the operator
 * (when in manual mode), by the agent or by instruction (when in agent mode).
 * 
 * @author Lene Hallen
 * @author Lise Engmo
 */
public enum ChokeAdjuster {

	AGENT("Agent", "agent"), 
	OPERATOR("Operator", "operator"), 
	INSTRUCTION("Instruction", "instruction");

	private String longname;
	private String shortname;

	private ChokeAdjuster(String longname, String shortname) {
		this.longname = longname;
		this.shortname = shortname;
	}

	public String getLongname() {
		return this.longname;
	}

	public String getShortname() {
		return this.shortname;
	}

}
