package simulator.constants;

import java.awt.Color;
import java.math.BigDecimal;
import java.math.MathContext;

import javax.swing.SpringLayout;

public interface Constants {

	public static final MathContext CONTEXT = new MathContext(3);

	public static final int PLANT_INDEX = 0;
	
	public static final String N = SpringLayout.NORTH;
	public static final String S = SpringLayout.SOUTH;
	public static final String W = SpringLayout.WEST;
	public static final String E = SpringLayout.EAST;
	
	public static final int V_SPACING = 5;
	public static final int H_SPACING = 8;
	
	// Misc directories
	public static final String REPORT_DIR = "report\\";
	public static final String JACK_DIR = "jack\\";
	public static final String SRC_DIR = "src\\";
	public static final String BIN_DIR = "bin\\";
	public static final String CONFIG_DIR = "config\\";
	
	// Where to log the agent output
	public static final String AGENT_OUTPUT_FILENAME = "agent_out.txt";
	public static final String AGENT_ERROR_FILENAME = "agent_err.txt";

	// The critical limit for water in the plant per timetick
	public static final BigDecimal CRITICAL_WATER_LIMIT = new BigDecimal(70); 
	
	//The critical limit for sand in a well per timetick
	public static final BigDecimal CRITICAL_SAND_LIMIT = new BigDecimal(3);
	
	// Colours 
	public static final Color COLOR_SUCCESS = new Color(52, 142, 8);
	public static final Color COLOR_INFO = new Color(0, 0, 0);
	public static final Color COLOR_ERROR = new Color(237, 25, 25);

	// Colors used by the "slider" picturing the oil production
	public static final Color DIAGRAM_BACKGROUND = new Color(255, 255, 255);
	public static final Color DIAGRAM_BORDER = new Color(0, 0, 0);
	public static final Color DIAGRAM_OIL = new Color(70, 70, 70);
	public static final Color DIAGRAM_CRITICAL_CONDITION = new Color(237, 25, 25);
	public static final Color DIAGRAM_WATER = new Color(103, 103, 103);
	public static final Color DIAGRAM_SAND = new Color(140, 140, 140);

	// The colours marking which component is selected
	public final static Color SELECTED_BACKGROUND = new Color(248, 188, 213);
	public final static Color UNSELECTED_BACKGROUND = new Color(255, 255, 255);

	// How the production depends on permeability and choke
	public final static BigDecimal PERMEABILITY_CHOKE_DEPENDENCY = new BigDecimal(0.005);

	// Constants for the number of wells
	public final static int MINIMUM_NOF_WELLS = 1;
	public static final int MAXIMUM_NOF_WELLS = 4;
	public static final int DEFAULT_WELLCOUNT = 3;

	// Constants for the timelimit
	public static final int MINIMUM_TIMELIMIT = 10;
	public static final int MAXIMUM_TIMELIMIT = 500;
	public static final int DEFAULT_TIMELIMIT = 100;

	// Constants for the timetick interval
	public static final int MINIMUM_TIMETICK_INTERVAL = 10;
	public static final int MAXIMUM_TIMETICK_INTERVAL = 5000;
	public static final int DEFAULT_TIMETICK_INTERVAL = 1000;

	public static final SystemMode DEFAULT_SYSTEMMODE = SystemMode.AGENT;
	public static final String DEFAULT_COMMENT = "";

	
}
