package simulator.constants;

import java.awt.Color;

/**
 * Enum for the "loglevels", i.e. whether the output is of purely information
 * character or whether it is meant to draw the user's attention to an error.
 * 
 * @author Lene Hallen
 * @author Lise Engmo
 */
public enum LogLevel {

	INFO("Info", Color.BLACK), 
	ERROR("Error", Color.RED);

	private String name;
	private Color color;

	private LogLevel(String name, Color color) {
		this.name = name;
		this.color = color;
	}

	public String getName() {
		return name;
	}

	public Color getColor() {
		return color;
	}

}
