package simulator.constants;

/**
 * Enum used for defining the mode in which the system is running. In addition
 * to agent and manual state, an "illegal" state is included. This is used when
 * the testcase has not been correctly initialised and indicates a problem, e.g.
 * with the retrieval of information from the database.
 * 
 * @author Lene Hallen
 * @author Lise Engmo
 */
public enum SystemMode {

	AGENT("The agent system is doing its thing"), 
	MANUAL("The oil production must be manually controlled"), 
	ILLEGAL("The system is an illegal state");

	private String description;

	private SystemMode(String description) {
		this.description = description;
	}

	public String getDescription() {
		return description;
	}
}
