package simulator.field;

import simulator.constants.ComponentName;

/**
 * Abstract class for all components involved in oil production,
 * this includes the field, the wells and the plant.
 * 
 * @author Lene Hallen
 * @author Lise Engmo
 */
public abstract class OilProductionComponent {

	protected ComponentName name;

	public OilProductionComponent(ComponentName name) {
		this.name = name;
	}

	public ComponentName getName() {
		return name;
	}

	public String getShortName() {
		return name.getShortname();
	}
}
