package simulator.field;

import java.math.BigDecimal;

/**
 * Class which holds the time and value of a sensor reading
 * 
 * @author Lene Hallen
 * @author Lise Engmo
 */
public class SensorReading {

	private int time;
	private BigDecimal value;

	/**
	 * Default constructor. Sets fields to invalid values.
	 */
	public SensorReading() {
		this.time = -1;
		this.value = new BigDecimal(0);
	}

	/**
	 * Constructor. Initializes the fields.
	 * @param time the time of the sensor reading
	 * @param value the value of the sensor reading
	 */
	public SensorReading(int time, BigDecimal value) {
		this.time = time;
		this.value = value;
	}

	public int getTime() {
		return time;
	}

	public BigDecimal getValue() {
		return value;
	}
}
